package dk.itu.oop.lecture1;

/* The source of the river Sus is in Ggsmose.  
 * Sus has Kongskilde Bk, Sor  and Ringsted  as tributaries. 
 * The source of Kongskilde Bk is in Kongskilden. 
 * The source of Sor  is in Sor S. 
 * The source of Ringsted  is in Gyrstinge S.  
 * Ringsted  has Vigerdals as its sole tributary, 
 * whose source, in turn, is Valslille S. 
 * We will assign arbitrary length to rives, 
 * and arbitrary liters per hour to sources
 */
class WaterWayTest {
	public static void main(String[] args){
		WaterWay sus = new WaterWay("Sus", 65.4
			, new WaterSource("Ggsmose", 1200) );
		WaterWay kkbk =  new WaterWay("Kongskilde bk", 5.3
			, new WaterSource("Kongskilde", 680) );
		WaterWay sor = new WaterWay("Sor ", 18.3
			, new WaterSource("Sor s", 2100) );
		WaterWay ring = new WaterWay("Ringsted ", 22.6
			, new WaterSource("Gyrstinge S", 3500) );
		WaterWay vigerdals = new WaterWay("Vigerdals", 7.8
			, new WaterSource("Valslille s", 350) );
		sus.addTributary(kkbk);
		sus.addTributary(sor);
		sus.addTributary(ring);
		ring.addTributary(vigerdals);
		
		System.out.println("Total length of sus riversystem is: " 
			+ sus.totalLength() + " km."); // 119.4
			
		System.out.println("Total water flow of sus riversystem is: "
			+ WaterWay.totalLitersPrHour(sus) + " l/h"); // 7830
	}
}